SystemOrganization addCategory: #'AL-Tests-Storage'!

TestCase subclass: #ALEntityReferenceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Tests-Storage'!

!ALEntityReferenceTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/27/2012 20:30'!
testCreation
	| ref |
	ref := ALEntityReference key: 1.
	self assert: ref key = 1.
	self assert: (ref hasKey: 1).! !

!ALEntityReferenceTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/27/2012 20:34'!
testSetValue
	| ref |
	ref := ALEntityReference key: 1. 
	self
		should: [ref value: 'entity']
		raise: ALEditEntity! !

!ALEntityReferenceTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/27/2012 20:36'!
testSetValueKey
	| ref |
	ref := ALEntityReference key: 1. 
	[ref value: 'entity']
		on: ALEditEntity
		do: [:n |
			self assert: n key = 1.
			self assert: n entity = 'entity']! !

!ALEntityReferenceTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/27/2012 20:32'!
testValue
	| ref |
	ref := ALEntityReference key: 1. 
	self 
		should: [ref value]
		raise: ALReadEntity
		! !

!ALEntityReferenceTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/27/2012 20:38'!
testValueEntity
	| ref entity |
	ref := ALEntityReference key: 1. 
	entity := [ref value]
		on: ALReadEntity
		do: [:n | n resume: (ALEntityVariant key: n key entity: 'entity')].
	self assert: entity = 'entity'! !

!ALEntityReferenceTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/27/2012 20:33'!
testValueKey
	| ref |
	ref := ALEntityReference key: 1. 
	[ref value]
		on: ALReadEntity
		do: [:n | self assert: n key = 1]! !

!ALEntityReferenceTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/27/2012 20:39'!
testVariant
	| ref variant |
	ref := ALEntityReference key: 1. 
	variant := [ref variant]
		on: ALReadEntity
		do: [:n | n resume: (ALEntityVariant key: n key entity: 'entity')].
	self assert: variant class = ALEntityVariant.
	self assert: variant key = 1.
	self assert: variant entity = 'entity'.! !

TestCase subclass: #ALEntityVariantTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Tests-Storage'!

!ALEntityVariantTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/27/2012 20:43'!
testAsReference
	| ref variant |
	variant := ALEntityVariant key: 1 entity: 'entity'.
	ref := variant asReference.
	self assert: ref key = variant key! !

TestCase subclass: #ALRepositoryTest
	instanceVariableNames: 'repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Tests-Storage'!

ALRepositoryTest subclass: #ALMemoryRepositoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Tests-Storage'!

!ALMemoryRepositoryTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/27/2012 20:04'!
createRepository	
	^ ALMemoryRepository new! !

!ALRepositoryTest class methodsFor: 'as yet unclassified' stamp: 'cwp 12/27/2012 20:03'!
isAbstract
	^ self name = #ALRepositoryTest! !

!ALRepositoryTest class methodsFor: 'as yet unclassified' stamp: 'cwp 12/27/2012 19:59'!
shouldInheritSelectors
	^ true! !

!ALRepositoryTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/27/2012 19:58'!
setUp	
	repository := self createRepository
	! !

!ALRepositoryTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/27/2012 20:12'!
testAdd
	| variant |
	variant := repository add: 'entity'.
	self assert: variant key notNil.
	self assert: variant entity = 'entity'.
	self assert: variant version = 1! !

!ALRepositoryTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/27/2012 20:15'!
testCollect
	| one two variants |
	one := repository add: 'e1'.
	two := repository add: 'e2'.
	variants := repository collect: {one key. two key}.
	self assert: variants class == Array.
	self assert: variants first key = one key.
	self assert: variants first entity = 'e1'.
	self assert: variants first version = one version.
	self assert: variants second key = two key.
	self assert: variants second entity = 'e2'.
	self assert: variants second version = two version.
	! !

!ALRepositoryTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/27/2012 20:12'!
testDelete
	| variant |
	variant := repository add: 'entity'.
	repository delete: variant key.
	self
		should: [repository read: variant key]
		raise: ALStorageError! !

!ALRepositoryTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/27/2012 20:11'!
testEdit
	| one two |
	
	one := repository add: 'v1'.
	two := repository edit: one key value: 'v2'.
	self assert: two key = one key.
	self assert: two version > one version.
	self assert: two entity = 'v2'.
! !

!ALRepositoryTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/27/2012 20:21'!
testHandleAddNotification
	| one two |
	one := repository do: [ALAddEntity entity: 'entity'].
	two := repository read: one key.
	self assert: two key = one key.
	self assert: two version = one version.
	self assert: two entity = 'entity'.! !

!ALRepositoryTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/27/2012 20:21'!
testHandleCollectNotification
	| one two variants |
	one := repository add: 'e1'.
	two := repository add: 'e2'.
	variants := repository do:
		[ALCollectEntities keys: {one key. two key}].
	self assert: variants class == Array.
	self assert: variants first key = one key.
	self assert: variants first entity = 'e1'.
	self assert: variants first version = one version.
	self assert: variants second key = two key.
	self assert: variants second entity = 'e2'.
	self assert: variants second version = two version.
	! !

!ALRepositoryTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/27/2012 20:21'!
testHandleDeleteNotification
	| variant |
	variant := repository add: 'entity'.
	repository do: [ALDeleteEntity key: variant key].
	self
		should: [repository read: variant key]
		raise: ALStorageError! !

!ALRepositoryTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/27/2012 20:22'!
testHandleEditNotification
	| one two |
	
	one := repository add: 'v1'.
	two := repository do: [ALEditEntity key: one key entity: 'v2'].
	self assert: two key = one key.
	self assert: two version > one version.
	self assert: two entity = 'v2'.
! !

!ALRepositoryTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/27/2012 20:29'!
testHandleReadNotification
	| one two |
	one := repository add: 'entity'.
	two := repository do: [ALReadEntity key: one key].
	self assert: one key = two key.
	self assert: one entity = 'entity'.
	self assert: one version = two version! !

!ALRepositoryTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/27/2012 20:13'!
testRead
	| one two |
	one := repository add: 'entity'.
	two := repository read: one key.
	self assert: one key = two key.
	self assert: one entity = 'entity'.
	self assert: one version = two version! !
